/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSGPUOutOfMemoryError.h"

#include "ActiveDOMObject.h"
#include "DOMIsoSubspaces.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructor.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObjectInlines.h"
#include "JSDOMWrapperCache.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsGPUOutOfMemoryErrorConstructor);

class JSGPUOutOfMemoryErrorPrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSGPUOutOfMemoryErrorPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSGPUOutOfMemoryErrorPrototype* ptr = new (NotNull, JSC::allocateCell<JSGPUOutOfMemoryErrorPrototype>(vm)) JSGPUOutOfMemoryErrorPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSGPUOutOfMemoryErrorPrototype, Base);
        return &vm.plainObjectSpace;
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSGPUOutOfMemoryErrorPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSGPUOutOfMemoryErrorPrototype, JSGPUOutOfMemoryErrorPrototype::Base);

using JSGPUOutOfMemoryErrorDOMConstructor = JSDOMConstructor<JSGPUOutOfMemoryError>;

template<> EncodedJSValue JSC_HOST_CALL_ATTRIBUTES JSGPUOutOfMemoryErrorDOMConstructor::construct(JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame)
{
    VM& vm = lexicalGlobalObject->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* castedThis = jsCast<JSGPUOutOfMemoryErrorDOMConstructor*>(callFrame->jsCallee());
    ASSERT(castedThis);
    auto object = GPUOutOfMemoryError::create();
    static_assert(TypeOrExceptionOrUnderlyingType<decltype(object)>::isRef);
    auto jsValue = toJSNewlyCreated<IDLInterface<GPUOutOfMemoryError>>(*lexicalGlobalObject, *castedThis->globalObject(), throwScope, WTFMove(object));
    if constexpr (IsExceptionOr<decltype(object)>)
        RETURN_IF_EXCEPTION(throwScope, { });
    setSubclassStructureIfNeeded<GPUOutOfMemoryError>(lexicalGlobalObject, callFrame, asObject(jsValue));
    RETURN_IF_EXCEPTION(throwScope, { });
    return JSValue::encode(jsValue);
}
JSC_ANNOTATE_HOST_FUNCTION(JSGPUOutOfMemoryErrorDOMConstructorConstruct, JSGPUOutOfMemoryErrorDOMConstructor::construct);

template<> const ClassInfo JSGPUOutOfMemoryErrorDOMConstructor::s_info = { "GPUOutOfMemoryError", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSGPUOutOfMemoryErrorDOMConstructor) };

template<> JSValue JSGPUOutOfMemoryErrorDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSGPUOutOfMemoryErrorDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    JSString* nameString = jsNontrivialString(vm, "GPUOutOfMemoryError"_s);
    m_originalName.set(vm, this, nameString);
    putDirect(vm, vm.propertyNames->name, nameString, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->prototype, JSGPUOutOfMemoryError::prototype(vm, globalObject), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::DontDelete);
}

/* Hash table for prototype */

static const HashTableValue JSGPUOutOfMemoryErrorPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUOutOfMemoryErrorConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSGPUOutOfMemoryErrorPrototype::s_info = { "GPUOutOfMemoryError", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSGPUOutOfMemoryErrorPrototype) };

void JSGPUOutOfMemoryErrorPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSGPUOutOfMemoryError::info(), JSGPUOutOfMemoryErrorPrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSGPUOutOfMemoryError::s_info = { "GPUOutOfMemoryError", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSGPUOutOfMemoryError) };

JSGPUOutOfMemoryError::JSGPUOutOfMemoryError(Structure* structure, JSDOMGlobalObject& globalObject, Ref<GPUOutOfMemoryError>&& impl)
    : JSDOMWrapper<GPUOutOfMemoryError>(structure, globalObject, WTFMove(impl))
{
}

void JSGPUOutOfMemoryError::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

    static_assert(!std::is_base_of<ActiveDOMObject, GPUOutOfMemoryError>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

}

JSObject* JSGPUOutOfMemoryError::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSGPUOutOfMemoryErrorPrototype::create(vm, &globalObject, JSGPUOutOfMemoryErrorPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSGPUOutOfMemoryError::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSGPUOutOfMemoryError>(vm, globalObject);
}

JSValue JSGPUOutOfMemoryError::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSGPUOutOfMemoryErrorDOMConstructor, DOMConstructorID::GPUOutOfMemoryError>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSGPUOutOfMemoryError::destroy(JSC::JSCell* cell)
{
    JSGPUOutOfMemoryError* thisObject = static_cast<JSGPUOutOfMemoryError*>(cell);
    thisObject->JSGPUOutOfMemoryError::~JSGPUOutOfMemoryError();
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUOutOfMemoryErrorConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSGPUOutOfMemoryErrorPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSGPUOutOfMemoryError::getConstructor(JSC::getVM(lexicalGlobalObject), prototype->globalObject()));
}

JSC::IsoSubspace* JSGPUOutOfMemoryError::subspaceForImpl(JSC::VM& vm)
{
    auto& clientData = *static_cast<JSVMClientData*>(vm.clientData);
    auto& spaces = clientData.subspaces();
    if (auto* space = spaces.m_subspaceForGPUOutOfMemoryError.get())
        return space;
    static_assert(std::is_base_of_v<JSC::JSDestructibleObject, JSGPUOutOfMemoryError> || !JSGPUOutOfMemoryError::needsDestruction);
    if constexpr (std::is_base_of_v<JSC::JSDestructibleObject, JSGPUOutOfMemoryError>)
        spaces.m_subspaceForGPUOutOfMemoryError = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, *vm.destructibleObjectHeapCellType, JSGPUOutOfMemoryError);
    else
        spaces.m_subspaceForGPUOutOfMemoryError = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, *vm.cellHeapCellType, JSGPUOutOfMemoryError);
    auto* space = spaces.m_subspaceForGPUOutOfMemoryError.get();
IGNORE_WARNINGS_BEGIN("unreachable-code")
IGNORE_WARNINGS_BEGIN("tautological-compare")
    void (*myVisitOutputConstraint)(JSC::JSCell*, JSC::SlotVisitor&) = JSGPUOutOfMemoryError::visitOutputConstraints;
    void (*jsCellVisitOutputConstraint)(JSC::JSCell*, JSC::SlotVisitor&) = JSC::JSCell::visitOutputConstraints;
    if (myVisitOutputConstraint != jsCellVisitOutputConstraint)
        clientData.outputConstraintSpaces().append(space);
IGNORE_WARNINGS_END
IGNORE_WARNINGS_END
    return space;
}

void JSGPUOutOfMemoryError::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSGPUOutOfMemoryError*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

bool JSGPUOutOfMemoryErrorOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, AbstractSlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSGPUOutOfMemoryErrorOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsGPUOutOfMemoryError = static_cast<JSGPUOutOfMemoryError*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsGPUOutOfMemoryError->wrapped(), jsGPUOutOfMemoryError);
}

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<GPUOutOfMemoryError>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to GPUOutOfMemoryError.
    static_assert(!std::is_polymorphic<GPUOutOfMemoryError>::value, "GPUOutOfMemoryError is polymorphic but the IDL claims it is not");
    return createWrapper<GPUOutOfMemoryError>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, GPUOutOfMemoryError& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

GPUOutOfMemoryError* JSGPUOutOfMemoryError::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSGPUOutOfMemoryError*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
