/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSGPUPipelineStatisticName.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(GPUPipelineStatisticName enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("vertex-shader-invocations"),
        MAKE_STATIC_STRING_IMPL("clipper-invocations"),
        MAKE_STATIC_STRING_IMPL("clipper-primitives-out"),
        MAKE_STATIC_STRING_IMPL("fragment-shader-invocations"),
        MAKE_STATIC_STRING_IMPL("compute-shader-invocations"),
    };
    static_assert(static_cast<size_t>(GPUPipelineStatisticName::VertexShaderInvocations) == 0, "GPUPipelineStatisticName::VertexShaderInvocations is not 0 as expected");
    static_assert(static_cast<size_t>(GPUPipelineStatisticName::ClipperInvocations) == 1, "GPUPipelineStatisticName::ClipperInvocations is not 1 as expected");
    static_assert(static_cast<size_t>(GPUPipelineStatisticName::ClipperPrimitivesOut) == 2, "GPUPipelineStatisticName::ClipperPrimitivesOut is not 2 as expected");
    static_assert(static_cast<size_t>(GPUPipelineStatisticName::FragmentShaderInvocations) == 3, "GPUPipelineStatisticName::FragmentShaderInvocations is not 3 as expected");
    static_assert(static_cast<size_t>(GPUPipelineStatisticName::ComputeShaderInvocations) == 4, "GPUPipelineStatisticName::ComputeShaderInvocations is not 4 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(JSGlobalObject& lexicalGlobalObject, GPUPipelineStatisticName enumerationValue)
{
    return jsStringWithCache(lexicalGlobalObject.vm(), convertEnumerationToString(enumerationValue));
}

template<> std::optional<GPUPipelineStatisticName> parseEnumeration<GPUPipelineStatisticName>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto stringValue = value.toWTFString(&lexicalGlobalObject);
    if (stringValue == "vertex-shader-invocations")
        return GPUPipelineStatisticName::VertexShaderInvocations;
    if (stringValue == "clipper-invocations")
        return GPUPipelineStatisticName::ClipperInvocations;
    if (stringValue == "clipper-primitives-out")
        return GPUPipelineStatisticName::ClipperPrimitivesOut;
    if (stringValue == "fragment-shader-invocations")
        return GPUPipelineStatisticName::FragmentShaderInvocations;
    if (stringValue == "compute-shader-invocations")
        return GPUPipelineStatisticName::ComputeShaderInvocations;
    return std::nullopt;
}

template<> const char* expectedEnumerationValues<GPUPipelineStatisticName>()
{
    return "\"vertex-shader-invocations\", \"clipper-invocations\", \"clipper-primitives-out\", \"fragment-shader-invocations\", \"compute-shader-invocations\"";
}

} // namespace WebCore
