/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSGPUTextureUsage.h"

#include "ActiveDOMObject.h"
#include "DOMIsoSubspaces.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObjectInlines.h"
#include "JSDOMWrapperCache.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsGPUTextureUsageConstructor);

class JSGPUTextureUsagePrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSGPUTextureUsagePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSGPUTextureUsagePrototype* ptr = new (NotNull, JSC::allocateCell<JSGPUTextureUsagePrototype>(vm)) JSGPUTextureUsagePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSGPUTextureUsagePrototype, Base);
        return &vm.plainObjectSpace;
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSGPUTextureUsagePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSGPUTextureUsagePrototype, JSGPUTextureUsagePrototype::Base);

using JSGPUTextureUsageDOMConstructor = JSDOMConstructorNotConstructable<JSGPUTextureUsage>;

/* Hash table for constructor */

static const HashTableValue JSGPUTextureUsageConstructorTableValues[] =
{
    { "COPY_SRC", JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::ConstantInteger, NoIntrinsic, { (long long)(0x01) } },
    { "COPY_DST", JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::ConstantInteger, NoIntrinsic, { (long long)(0x02) } },
    { "TEXTURE_BINDING", JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::ConstantInteger, NoIntrinsic, { (long long)(0x04) } },
    { "STORAGE_BINDING", JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::ConstantInteger, NoIntrinsic, { (long long)(0x08) } },
    { "RENDER_ATTACHMENT", JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::ConstantInteger, NoIntrinsic, { (long long)(0x10) } },
};

static_assert(GPUTextureUsage::COPY_SRC == 0x01, "COPY_SRC in GPUTextureUsage does not match value from IDL");
static_assert(GPUTextureUsage::COPY_DST == 0x02, "COPY_DST in GPUTextureUsage does not match value from IDL");
static_assert(GPUTextureUsage::TEXTURE_BINDING == 0x04, "TEXTURE_BINDING in GPUTextureUsage does not match value from IDL");
static_assert(GPUTextureUsage::STORAGE_BINDING == 0x08, "STORAGE_BINDING in GPUTextureUsage does not match value from IDL");
static_assert(GPUTextureUsage::RENDER_ATTACHMENT == 0x10, "RENDER_ATTACHMENT in GPUTextureUsage does not match value from IDL");

template<> const ClassInfo JSGPUTextureUsageDOMConstructor::s_info = { "GPUTextureUsage", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSGPUTextureUsageDOMConstructor) };

template<> JSValue JSGPUTextureUsageDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSGPUTextureUsageDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    JSString* nameString = jsNontrivialString(vm, "GPUTextureUsage"_s);
    m_originalName.set(vm, this, nameString);
    putDirect(vm, vm.propertyNames->name, nameString, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->prototype, JSGPUTextureUsage::prototype(vm, globalObject), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::DontDelete);
    reifyStaticProperties(vm, JSGPUTextureUsage::info(), JSGPUTextureUsageConstructorTableValues, *this);
}

/* Hash table for prototype */

static const HashTableValue JSGPUTextureUsagePrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsGPUTextureUsageConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "COPY_SRC", JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::ConstantInteger, NoIntrinsic, { (long long)(0x01) } },
    { "COPY_DST", JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::ConstantInteger, NoIntrinsic, { (long long)(0x02) } },
    { "TEXTURE_BINDING", JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::ConstantInteger, NoIntrinsic, { (long long)(0x04) } },
    { "STORAGE_BINDING", JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::ConstantInteger, NoIntrinsic, { (long long)(0x08) } },
    { "RENDER_ATTACHMENT", JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::ConstantInteger, NoIntrinsic, { (long long)(0x10) } },
};

const ClassInfo JSGPUTextureUsagePrototype::s_info = { "GPUTextureUsage", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSGPUTextureUsagePrototype) };

void JSGPUTextureUsagePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSGPUTextureUsage::info(), JSGPUTextureUsagePrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSGPUTextureUsage::s_info = { "GPUTextureUsage", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSGPUTextureUsage) };

JSGPUTextureUsage::JSGPUTextureUsage(Structure* structure, JSDOMGlobalObject& globalObject, Ref<GPUTextureUsage>&& impl)
    : JSDOMWrapper<GPUTextureUsage>(structure, globalObject, WTFMove(impl))
{
}

void JSGPUTextureUsage::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

    static_assert(!std::is_base_of<ActiveDOMObject, GPUTextureUsage>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

}

JSObject* JSGPUTextureUsage::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSGPUTextureUsagePrototype::create(vm, &globalObject, JSGPUTextureUsagePrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSGPUTextureUsage::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSGPUTextureUsage>(vm, globalObject);
}

JSValue JSGPUTextureUsage::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSGPUTextureUsageDOMConstructor, DOMConstructorID::GPUTextureUsage>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSGPUTextureUsage::destroy(JSC::JSCell* cell)
{
    JSGPUTextureUsage* thisObject = static_cast<JSGPUTextureUsage*>(cell);
    thisObject->JSGPUTextureUsage::~JSGPUTextureUsage();
}

JSC_DEFINE_CUSTOM_GETTER(jsGPUTextureUsageConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSGPUTextureUsagePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSGPUTextureUsage::getConstructor(JSC::getVM(lexicalGlobalObject), prototype->globalObject()));
}

JSC::IsoSubspace* JSGPUTextureUsage::subspaceForImpl(JSC::VM& vm)
{
    auto& clientData = *static_cast<JSVMClientData*>(vm.clientData);
    auto& spaces = clientData.subspaces();
    if (auto* space = spaces.m_subspaceForGPUTextureUsage.get())
        return space;
    static_assert(std::is_base_of_v<JSC::JSDestructibleObject, JSGPUTextureUsage> || !JSGPUTextureUsage::needsDestruction);
    if constexpr (std::is_base_of_v<JSC::JSDestructibleObject, JSGPUTextureUsage>)
        spaces.m_subspaceForGPUTextureUsage = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, *vm.destructibleObjectHeapCellType, JSGPUTextureUsage);
    else
        spaces.m_subspaceForGPUTextureUsage = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, *vm.cellHeapCellType, JSGPUTextureUsage);
    auto* space = spaces.m_subspaceForGPUTextureUsage.get();
IGNORE_WARNINGS_BEGIN("unreachable-code")
IGNORE_WARNINGS_BEGIN("tautological-compare")
    void (*myVisitOutputConstraint)(JSC::JSCell*, JSC::SlotVisitor&) = JSGPUTextureUsage::visitOutputConstraints;
    void (*jsCellVisitOutputConstraint)(JSC::JSCell*, JSC::SlotVisitor&) = JSC::JSCell::visitOutputConstraints;
    if (myVisitOutputConstraint != jsCellVisitOutputConstraint)
        clientData.outputConstraintSpaces().append(space);
IGNORE_WARNINGS_END
IGNORE_WARNINGS_END
    return space;
}

void JSGPUTextureUsage::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSGPUTextureUsage*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

bool JSGPUTextureUsageOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, AbstractSlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSGPUTextureUsageOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsGPUTextureUsage = static_cast<JSGPUTextureUsage*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsGPUTextureUsage->wrapped(), jsGPUTextureUsage);
}

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<GPUTextureUsage>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to GPUTextureUsage.
    static_assert(!std::is_polymorphic<GPUTextureUsage>::value, "GPUTextureUsage is polymorphic but the IDL claims it is not");
    return createWrapper<GPUTextureUsage>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, GPUTextureUsage& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

GPUTextureUsage* JSGPUTextureUsage::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSGPUTextureUsage*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
