/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSWebLockManager.h"

#include "ActiveDOMObject.h"
#include "DOMIsoSubspaces.h"
#include "DOMPromiseProxy.h"
#include "JSAbortSignal.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertAny.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertCallbacks.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertPromise.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMGlobalObjectInlines.h"
#include "JSDOMOperation.h"
#include "JSDOMOperationReturningPromise.h"
#include "JSDOMWrapperCache.h"
#include "JSWebLockGrantedCallback.h"
#include "JSWebLockMode.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSArray.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

template<> WebLockManager::Options convertDictionary<WebLockManager::Options>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    VM& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return { };
    }
    WebLockManager::Options result;
    JSValue ifAvailableValue;
    if (isNullOrUndefined)
        ifAvailableValue = jsUndefined();
    else {
        ifAvailableValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "ifAvailable"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!ifAvailableValue.isUndefined()) {
        result.ifAvailable = convert<IDLBoolean>(lexicalGlobalObject, ifAvailableValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.ifAvailable = false;
    JSValue modeValue;
    if (isNullOrUndefined)
        modeValue = jsUndefined();
    else {
        modeValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "mode"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!modeValue.isUndefined()) {
        result.mode = convert<IDLEnumeration<WebLockMode>>(lexicalGlobalObject, modeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.mode = WebLockMode::Exclusive;
    JSValue signalValue;
    if (isNullOrUndefined)
        signalValue = jsUndefined();
    else {
        signalValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "signal"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!signalValue.isUndefined()) {
        result.signal = convert<IDLInterface<AbortSignal>>(lexicalGlobalObject, signalValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue stealValue;
    if (isNullOrUndefined)
        stealValue = jsUndefined();
    else {
        stealValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "steal"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!stealValue.isUndefined()) {
        result.steal = convert<IDLBoolean>(lexicalGlobalObject, stealValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.steal = false;
    return result;
}

template<> WebLockManager::Snapshot convertDictionary<WebLockManager::Snapshot>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    VM& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return { };
    }
    WebLockManager::Snapshot result;
    JSValue heldValue;
    if (isNullOrUndefined)
        heldValue = jsUndefined();
    else {
        heldValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "held"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!heldValue.isUndefined()) {
        result.held = convert<IDLSequence<IDLDictionary<WebLockManager::Info>>>(lexicalGlobalObject, heldValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue pendingValue;
    if (isNullOrUndefined)
        pendingValue = jsUndefined();
    else {
        pendingValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "pending"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!pendingValue.isUndefined()) {
        result.pending = convert<IDLSequence<IDLDictionary<WebLockManager::Info>>>(lexicalGlobalObject, pendingValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    return result;
}

template<> WebLockManager::Info convertDictionary<WebLockManager::Info>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    VM& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return { };
    }
    WebLockManager::Info result;
    JSValue clientIdValue;
    if (isNullOrUndefined)
        clientIdValue = jsUndefined();
    else {
        clientIdValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "clientId"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!clientIdValue.isUndefined()) {
        result.clientId = convert<IDLDOMString>(lexicalGlobalObject, clientIdValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue modeValue;
    if (isNullOrUndefined)
        modeValue = jsUndefined();
    else {
        modeValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "mode"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!modeValue.isUndefined()) {
        result.mode = convert<IDLEnumeration<WebLockMode>>(lexicalGlobalObject, modeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue nameValue;
    if (isNullOrUndefined)
        nameValue = jsUndefined();
    else {
        nameValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "name"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!nameValue.isUndefined()) {
        result.name = convert<IDLDOMString>(lexicalGlobalObject, nameValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    return result;
}

// Functions

static JSC_DECLARE_HOST_FUNCTION(jsWebLockManagerPrototypeFunction_request);
static JSC_DECLARE_HOST_FUNCTION(jsWebLockManagerPrototypeFunction_query);

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsWebLockManagerConstructor);

class JSWebLockManagerPrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSWebLockManagerPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSWebLockManagerPrototype* ptr = new (NotNull, JSC::allocateCell<JSWebLockManagerPrototype>(vm)) JSWebLockManagerPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSWebLockManagerPrototype, Base);
        return &vm.plainObjectSpace;
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSWebLockManagerPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSWebLockManagerPrototype, JSWebLockManagerPrototype::Base);

using JSWebLockManagerDOMConstructor = JSDOMConstructorNotConstructable<JSWebLockManager>;

template<> const ClassInfo JSWebLockManagerDOMConstructor::s_info = { "LockManager", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebLockManagerDOMConstructor) };

template<> JSValue JSWebLockManagerDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSWebLockManagerDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    JSString* nameString = jsNontrivialString(vm, "LockManager"_s);
    m_originalName.set(vm, this, nameString);
    putDirect(vm, vm.propertyNames->name, nameString, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->prototype, JSWebLockManager::prototype(vm, globalObject), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::DontDelete);
}

/* Hash table for prototype */

static const HashTableValue JSWebLockManagerPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebLockManagerConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "request", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsWebLockManagerPrototypeFunction_request), (intptr_t) (2) } },
    { "query", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsWebLockManagerPrototypeFunction_query), (intptr_t) (0) } },
};

const ClassInfo JSWebLockManagerPrototype::s_info = { "LockManager", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebLockManagerPrototype) };

void JSWebLockManagerPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSWebLockManager::info(), JSWebLockManagerPrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSWebLockManager::s_info = { "LockManager", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebLockManager) };

JSWebLockManager::JSWebLockManager(Structure* structure, JSDOMGlobalObject& globalObject, Ref<WebLockManager>&& impl)
    : JSDOMWrapper<WebLockManager>(structure, globalObject, WTFMove(impl))
{
}

void JSWebLockManager::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

    static_assert(!std::is_base_of<ActiveDOMObject, WebLockManager>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

}

JSObject* JSWebLockManager::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSWebLockManagerPrototype::create(vm, &globalObject, JSWebLockManagerPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSWebLockManager::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSWebLockManager>(vm, globalObject);
}

JSValue JSWebLockManager::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSWebLockManagerDOMConstructor, DOMConstructorID::WebLockManager>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSWebLockManager::destroy(JSC::JSCell* cell)
{
    JSWebLockManager* thisObject = static_cast<JSWebLockManager*>(cell);
    thisObject->JSWebLockManager::~JSWebLockManager();
}

JSC_DEFINE_CUSTOM_GETTER(jsWebLockManagerConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSWebLockManagerPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSWebLockManager::getConstructor(JSC::getVM(lexicalGlobalObject), prototype->globalObject()));
}

static inline JSC::EncodedJSValue jsWebLockManagerPrototypeFunction_request1Body(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperationReturningPromise<JSWebLockManager>::ClassParameter castedThis, Ref<DeferredPromise>&& promise)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto name = convert<IDLDOMString>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument1 = callFrame->uncheckedArgument(1);
    auto grantedCallback = convert<IDLCallbackFunction<JSWebLockGrantedCallback>>(*lexicalGlobalObject, argument1.value(), *castedThis->globalObject(), [](JSC::JSGlobalObject& lexicalGlobalObject, JSC::ThrowScope& scope) { throwArgumentMustBeFunctionError(lexicalGlobalObject, scope, 1, "grantedCallback", "LockManager", "request"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLPromise<IDLAny>>(*lexicalGlobalObject, *castedThis->globalObject(), throwScope, [&]() -> decltype(auto) { return impl.request(WTFMove(name), grantedCallback.releaseNonNull(), WTFMove(promise)); })));
}

static inline JSC::EncodedJSValue jsWebLockManagerPrototypeFunction_request2Body(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperationReturningPromise<JSWebLockManager>::ClassParameter castedThis, Ref<DeferredPromise>&& promise)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto name = convert<IDLDOMString>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument1 = callFrame->uncheckedArgument(1);
    auto options = convert<IDLDictionary<WebLockManager::Options>>(*lexicalGlobalObject, argument1.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument2 = callFrame->uncheckedArgument(2);
    auto grantedCallback = convert<IDLCallbackFunction<JSWebLockGrantedCallback>>(*lexicalGlobalObject, argument2.value(), *castedThis->globalObject(), [](JSC::JSGlobalObject& lexicalGlobalObject, JSC::ThrowScope& scope) { throwArgumentMustBeFunctionError(lexicalGlobalObject, scope, 2, "grantedCallback", "LockManager", "request"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLPromise<IDLAny>>(*lexicalGlobalObject, *castedThis->globalObject(), throwScope, [&]() -> decltype(auto) { return impl.request(WTFMove(name), WTFMove(options), grantedCallback.releaseNonNull(), WTFMove(promise)); })));
}

static inline JSC::EncodedJSValue jsWebLockManagerPrototypeFunction_requestOverloadDispatcher(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperationReturningPromise<JSWebLockManager>::ClassParameter castedThis, Ref<DeferredPromise>&& promise)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    size_t argsCount = std::min<size_t>(3, callFrame->argumentCount());
    if (argsCount == 2) {
        RELEASE_AND_RETURN(throwScope, (jsWebLockManagerPrototypeFunction_request1Body(lexicalGlobalObject, callFrame, castedThis, WTFMove(promise))));
    }
    if (argsCount == 3) {
        RELEASE_AND_RETURN(throwScope, (jsWebLockManagerPrototypeFunction_request2Body(lexicalGlobalObject, callFrame, castedThis, WTFMove(promise))));
    }
    return argsCount < 2 ? throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject)) : throwVMTypeError(lexicalGlobalObject, throwScope);
}

JSC_DEFINE_HOST_FUNCTION(jsWebLockManagerPrototypeFunction_request, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperationReturningPromise<JSWebLockManager>::call<jsWebLockManagerPrototypeFunction_requestOverloadDispatcher>(*lexicalGlobalObject, *callFrame, "request");
}

static inline JSC::EncodedJSValue jsWebLockManagerPrototypeFunction_queryBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperationReturningPromise<JSWebLockManager>::ClassParameter castedThis, Ref<DeferredPromise>&& promise)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLPromise<IDLDictionary<WebLockManager::Snapshot>>>(*lexicalGlobalObject, *castedThis->globalObject(), throwScope, [&]() -> decltype(auto) { return impl.query(WTFMove(promise)); })));
}

JSC_DEFINE_HOST_FUNCTION(jsWebLockManagerPrototypeFunction_query, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperationReturningPromise<JSWebLockManager>::call<jsWebLockManagerPrototypeFunction_queryBody>(*lexicalGlobalObject, *callFrame, "query");
}

JSC::IsoSubspace* JSWebLockManager::subspaceForImpl(JSC::VM& vm)
{
    auto& clientData = *static_cast<JSVMClientData*>(vm.clientData);
    auto& spaces = clientData.subspaces();
    if (auto* space = spaces.m_subspaceForWebLockManager.get())
        return space;
    static_assert(std::is_base_of_v<JSC::JSDestructibleObject, JSWebLockManager> || !JSWebLockManager::needsDestruction);
    if constexpr (std::is_base_of_v<JSC::JSDestructibleObject, JSWebLockManager>)
        spaces.m_subspaceForWebLockManager = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, *vm.destructibleObjectHeapCellType, JSWebLockManager);
    else
        spaces.m_subspaceForWebLockManager = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, *vm.cellHeapCellType, JSWebLockManager);
    auto* space = spaces.m_subspaceForWebLockManager.get();
IGNORE_WARNINGS_BEGIN("unreachable-code")
IGNORE_WARNINGS_BEGIN("tautological-compare")
    void (*myVisitOutputConstraint)(JSC::JSCell*, JSC::SlotVisitor&) = JSWebLockManager::visitOutputConstraints;
    void (*jsCellVisitOutputConstraint)(JSC::JSCell*, JSC::SlotVisitor&) = JSC::JSCell::visitOutputConstraints;
    if (myVisitOutputConstraint != jsCellVisitOutputConstraint)
        clientData.outputConstraintSpaces().append(space);
IGNORE_WARNINGS_END
IGNORE_WARNINGS_END
    return space;
}

void JSWebLockManager::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSWebLockManager*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

bool JSWebLockManagerOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, AbstractSlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSWebLockManagerOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsWebLockManager = static_cast<JSWebLockManager*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsWebLockManager->wrapped(), jsWebLockManager);
}

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<WebLockManager>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to WebLockManager.
    static_assert(!std::is_polymorphic<WebLockManager>::value, "WebLockManager is polymorphic but the IDL claims it is not");
    return createWrapper<WebLockManager>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, WebLockManager& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

WebLockManager* JSWebLockManager::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSWebLockManager*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
